#include <cstdlib>
#include <cstdio>
#include <iostream>
using namespace std;
const int matrixSize = 20; //Defines x and y dimensions of matrix

typedef struct matElement
{
	int i, j;
	int element;
};
typedef struct matrix
{
	matElement ELEMENT[matrixSize][matrixSize];
};
void squareMatrix(matrix**, int);
void squareMatrixD(matrix**, int);
int A(int, int);
int s(int, int);

int main()
{
	matrix* S = (matrix*)malloc(sizeof(matrix));
	printf("ORIGINAL MATRIX:\n");
	for(int x = 0; x < matrixSize; x++)
	{
		for(int y = 0; y < matrixSize; y++)
		{
			S->ELEMENT[x][y].i = x;
			S->ELEMENT[x][y].j = y;
			S->ELEMENT[x][y].element = s(S->ELEMENT[x][y].i, S->ELEMENT[x][y].j);
		}
	}
	for(int x = 0; x < matrixSize; x++)
	{
		for(int y = 0; y < matrixSize; y++)
		{
			printf("%d ", S->ELEMENT[x][y].element);
		}
		printf("\n");
	}

	matrix* S2 = (matrix*)malloc(sizeof(matrix)); //Make copy of original matrix
	S2 = (matrix*)memcpy(S2, S, sizeof(matrix));

	squareMatrix(&S, matrixSize);
	printf("\nSQUARED MATRIX (LONG VERSION):\n\n");
	for(int x = 0; x < matrixSize; x++)
	{
		for(int y = 0; y < matrixSize; y++)
		{
			printf("%d ", S->ELEMENT[x][y].element);
		}
		printf("\n");
	}
	squareMatrixD(&S2, matrixSize);
	printf("\nSQUARED MATRIX (SHORT VERSION):\n\n");
	for(int x = 0; x < matrixSize; x++)
	{
		for(int y = 0; y < matrixSize; y++)
		{
			printf("%d ", S2->ELEMENT[x][y].element);
		}
		printf("\n");
	}

	free(S);
	free(S2);
	system("PAUSE");
	return 0;
}
void squareMatrix(matrix** S, int size) //Long (inefficient) version; works for any matrix
{
	matrix* newMatrix = (matrix*)malloc(sizeof(matrix));

	for(int x = 0; x < size; x++)
	{
		for(int y = 0; y < size; y++)
		{
			newMatrix->ELEMENT[x][y].element=0;
			for(int z = 0; z < size; z++)
			{
				newMatrix->ELEMENT[x][y].element+=(*S)->ELEMENT[x][z].element * (*S)->ELEMENT[z][y].element;
			}
		}
	}
	free(*S);
	(*S)=newMatrix;
}
void squareMatrixD(matrix** S, int size) //Short (efficient) version; assumes S is a diagonal matrix
{
	matrix* newMatrix = (matrix*)malloc(sizeof(matrix));
	for(int x = 0; x < size; x++)
	{
		for(int y = 0; y < size; y++)
		{
			if(x == y)
				newMatrix->ELEMENT[x][y].element = (*S)->ELEMENT[x][y].element * (*S)->ELEMENT[x][y].element;
			else
				newMatrix->ELEMENT[x][y].element = 0;
		}
	}
	free(*S);
	(*S)=newMatrix;
}
int s(int i, int j) 
{
      int a, b;
      a = i < j? j-i : i-j;
      b = (a + 51) / 52;
      return (1-b)*A(a,a); 
}
int A(int m, int n)
{
	if(m == 0)
		return n+1;
	else if(m > 0 && n == 0)
		return A(m-1,1);
	else //if(m > 0 && n > 0)
		return A(m-1, A(m-1,n-1));
}